/*
	Speccy Tracks Remake!
	
	Final Lap Music by Spectra
	- Plays a map-def defined song for the final lap 
*/

freeslot("sfx_finlap")

K_AddPThink(function(p)
	p.finallap = $ or false
	p.waitformusic = $ or (3*TICRATE)
	p.changedmusic = $ or false

	if mapheaderinfo[gamemap].finallapmusic // This Map has final lap music
	and p.laps == (mapheaderinfo[gamemap].numlaps)-1
	and p.finallap == false
		S_StartSound(nil, sfx_finlap, p)
		COM_BufInsertText(p, "tunes -none")
		p.waitformusic = $-1
		p.finallap = true
	end

	if p.waitformusic < 3*TICRATE and p.waitformusic > 0 then
		p.waitformusic = $-1
	end

	if p.waitformusic == 0 and p.changedmusic == false then
		COM_BufInsertText(p, "tunes "..mapheaderinfo[gamemap].finallapmusic)
		S_ShowMusicCredit(p)
		p.changedmusic = true
	end
end)

addHook("MapLoad", function()
	for p in players.iterate
		p.finallap = false
		p.waitformusic = 3*TICRATE
		p.changedmusic = false
	end
end)